#include <bits/stdc++.h>
using namespace std;

int n;
int a[1000005];
int suff[1000005];


int main()
{
    cin>>n;
    for(int i=0; i<n; i++)
        cin>>a[i];

    bool opadajuci=true;
    bool nerastuci=false;
    for(int i=0; i<n-1; i++)
    {
        if(a[i]==a[i+1])
            nerastuci=true;
        if(a[i]<a[i+1])
            opadajuci=false;
    }
    if(opadajuci)
    {
        if(!nerastuci)
            swap(a[n-2],a[n-1]);
        for(int i=0; i<n; i++)
            cout<<a[i]<<" ";
        return 0;
    }

    suff[n-1]=a[n-1];
    for(int i=n-2; i>=0; i--)
        suff[i]=max(suff[i+1],a[i]);
    for(int i=0; i<n-1; i++)
    {
        if(a[i]<suff[i])
        {
            int ind=-1;
            for(int j=n-1; j>=0; j--)
            {
                if(a[j]==suff[i])
                {
                    ind=j;
                    break;
                }
            }
            swap(a[i],a[ind]);
            break;
        }
        if(i==n-2)
            swap(a[i],a[i+1]);
    }
    for(int i=0; i<n; i++)
        cout<<a[i]<<" ";
    return 0;
}